/* Copyright (C) 2004 - 2005  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
namespace com.db4o.foundation.network
{
	public class YapSocketReal : com.db4o.foundation.network.YapSocket
	{
		private j4o.net.Socket _socket;

		private j4o.io.OutputStream _out;

		private j4o.io.InputStream _in;

		public YapSocketReal(j4o.net.Socket socket)
		{
			_socket = socket;
			_out = _socket.getOutputStream();
			_in = _socket.getInputStream();
		}

		public virtual void close()
		{
			_socket.close();
		}

		public virtual void flush()
		{
			_out.flush();
		}

		public virtual int read()
		{
			return _in.read();
		}

		public virtual int read(byte[] a_bytes, int a_offset, int a_length)
		{
			return _in.read(a_bytes, a_offset, a_length);
		}

		public virtual void setSoTimeout(int timeout)
		{
			try
			{
				_socket.setSoTimeout(timeout);
			}
			catch (System.Net.Sockets.SocketException e)
			{
				j4o.lang.JavaSystem.printStackTrace(e);
			}
		}

		public virtual void write(byte[] bytes)
		{
			_out.write(bytes);
		}

		public virtual void write(byte[] bytes, int off, int len)
		{
			_out.write(bytes, off, len);
		}

		public virtual void write(int i)
		{
			_out.write(i);
		}

		public virtual com.db4o.foundation.network.YapSocket openParalellSocket()
		{
			throw new System.IO.IOException();
		}
	}
}
